/*FILE: deriv_test.c

Programer: Sunethra Ramanan suna@physics.iitm.ac.in

Date:4 Jan 2013

Version: Original

Revision-History:
	4 Jan 2013

Comments:
26 Jan 2012: This calls deriv.c and calculates derivatives of function at a point x0.

4 Jan 2013: The second derivative has been taken out for class demonstration purposes.
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
/******************* Function prototype *************************************/

double
deriv(int opt, double x0, double h, double (*func) (double));

double
my_func(double x);
/*****************************************************************************/

int
main(void)
{
	int opt;									/*this chooses between forward or central difference: opt == 1 => forward difference and opt == 2 => central difference*/
	
	double x0;								/*point where the derivative is obtained*/
	double df;								/*variable that stores the derivative of exp(x)*/
	double h;									/*step size*/
	double exact;							/*exact value of the derivative*/
	double err;								/*this is the relative error*/
	
	/*initialization*/
	x0 = 1.0;
	
	h = 1e-07;
		
	/*derivative of 5/4 x*/
	exact = 5./4.;
	
	/*calculating derivative using forward difference*/
	opt = 1;
	
	printf("Calculating first derivative for h:%e \n\n", h);
	
	/*calling deriv.c*/
	df = deriv(opt, x0, h, &my_func);
	
	err = fabs((df - exact)/(exact));
	
	printf("forward difference h:%e x0:%f df:%f exact:%f err:%e \n", h, x0, df, exact, err);
		
	/*calculating derivative using central difference*/
	opt = 2;
	
	/*calling deriv.c*/
	df = deriv(opt, x0, h, &my_func);
	
	err = fabs((df - exact)/(exact));
	
	printf("Central difference h:%e x0:%f df:%f exact:%f err:%e \n\n", h, x0, df, exact, err);
			
	return(0);
}

/****************************************************************************/
double
my_func(double x)
{
	return(5/4 * x);
}
